/***************************************************************************
 * Copyright 2012 by
 *  + Christian-Albrechts-University of Kiel
 *    + Department of Computer Science
 *      + Software Engineering Group 
 *  and others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ***************************************************************************/
package kieker.webgui.converter;

import java.util.concurrent.ConcurrentHashMap;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.FacesConverter;

import kieker.analysis.model.analysisMetaModel.MIPort;

/**
 * 
 * @author Nils Christian Ehmke
 * @version 1.0
 */
@FacesConverter(value = MIPortToStringConverter.NAME)
public class MIPortToStringConverter implements Converter {
	/**
	 * This is the name of this converter.
	 */
	public static final String NAME = "kieker.webgui.converter.MIPortToStringConverter";
	/**
	 * This field stores the mapping.
	 */
	private static ConcurrentHashMap<String, MIPort> map = new ConcurrentHashMap<String, MIPort>();

	/**
	 * Creates a new instance of this class.
	 */
	public MIPortToStringConverter() {
		/* No code necessary. */
	}

	@Override
	public Object getAsObject(final FacesContext fc, final UIComponent uic, final String string) {
		return MIPortToStringConverter.map.get(string);
	}

	@Override
	public String getAsString(final FacesContext fc, final UIComponent uic, final Object o) {
		final String result = o.toString();
		MIPortToStringConverter.map.put(result, (MIPort) o);
		return result;
	}
}
